CREATE OR REPLACE VIEW place_label_z4toz5 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND scalerank IS NOT NULL
        AND scalerank < 3;

CREATE OR REPLACE VIEW place_label_z6 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND scalerank IS NOT NULL
        AND scalerank < 8;

CREATE OR REPLACE VIEW place_label_z7 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND scalerank IS NOT NULL;

CREATE OR REPLACE VIEW place_label_z8 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND type IN ('city', 'town');

CREATE OR REPLACE VIEW place_label_z9toz10 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND type IN ('city', 'town', 'district');

CREATE OR REPLACE VIEW place_label_z11toz12 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND type IN ('city', 'town', 'district', 'village');

CREATE OR REPLACE VIEW place_label_z13 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL
        AND type IN ('city', 'town', 'district', 'village', 'hamlet', 'suburb','neighbourhood');

CREATE OR REPLACE VIEW place_label_z14 AS
    SELECT * FROM (
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_point
        UNION ALL
        SELECT osm_id, geometry, timestamp, name, name_int, name_fr, name_en, name_de,
        name_es, name_ru, name_zh, type, population, capital, admin_level, scalerank
        FROM osm_place_polygon
    ) AS place_geoms
    WHERE name IS NOT NULL;

CREATE OR REPLACE VIEW place_label_layer AS (
    SELECT osm_id, timestamp, geometry FROM place_label_z4toz5
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z6
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z7
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z8
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z9toz10
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z11toz12
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z13
    UNION
    SELECT osm_id, timestamp, geometry FROM place_label_z14
);

CREATE OR REPLACE FUNCTION place_label_changed_tiles(ts timestamp)
RETURNS TABLE (x INTEGER, y INTEGER, z INTEGER) AS $$
BEGIN
	RETURN QUERY (
		WITH changed_tiles AS (
		    SELECT DISTINCT c.osm_id, t.tile_x AS x, t.tile_y AS y, t.tile_z AS z
		    FROM place_label_layer AS c
            INNER JOIN LATERAL overlapping_tiles(c.geometry, 14) AS t ON c.timestamp = ts
		)

		SELECT c.x, c.y, c.z FROM place_label_z14 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z = 14
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z13 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z = 13
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z11toz12 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z BETWEEN 11 AND 12
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z9toz10 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z BETWEEN 9 AND 10
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z8 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z = 8
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z7 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z = 7
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z6 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z = 6
		UNION

		SELECT c.x, c.y, c.z FROM place_label_z4toz5 AS l
		INNER JOIN changed_tiles AS c ON c.osm_id = l.osm_id AND c.z BETWEEN 4 AND 5
	);
END;
$$ LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION normalize_scalerank(scalerank INTEGER) RETURNS INTEGER
AS $$
BEGIN
    RETURN CASE
        WHEN scalerank >= 9 THEN 9
        ELSE scalerank
    END;
END;
$$ LANGUAGE plpgsql IMMUTABLE;
